import { Context, PublicKey } from '@metaplex-foundation/umi';
import { MetadataArgsArgs, MetadataArgsV2Args } from './generated';
import { LeafSchemaV2Flags } from './flags';
export declare function hash(input: Uint8Array | Uint8Array[]): Uint8Array;
export declare function hashLeaf(context: Pick<Context, 'eddsa' | 'programs'>, input: {
    merkleTree: PublicKey;
    owner: PublicKey;
    delegate?: PublicKey;
    leafIndex: number | bigint;
    metadata: MetadataArgsArgs;
    nftVersion?: number;
}): Uint8Array;
export declare function hashLeafV2(context: Pick<Context, 'eddsa' | 'programs'>, input: {
    merkleTree: PublicKey;
    owner: PublicKey;
    delegate?: PublicKey;
    leafIndex: number | bigint;
    metadata: MetadataArgsV2Args;
    assetData?: string | Uint8Array;
    flags?: LeafSchemaV2Flags;
    nftVersion?: number;
}): Uint8Array;
export declare function hashMetadata(metadata: MetadataArgsArgs): Uint8Array;
export declare function hashMetadataV2(metadata: MetadataArgsV2Args): Uint8Array;
export declare function hashMetadataData(metadata: MetadataArgsArgs): Uint8Array;
export declare function hashMetadataDataV2(metadata: MetadataArgsV2Args): Uint8Array;
export declare function hashMetadataCreators(creators: MetadataArgsArgs['creators']): Uint8Array;
export declare function hashCollection(collection: PublicKey): Uint8Array;
export declare function hashAssetData(assetData?: string | Uint8Array): Uint8Array;
